/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// Block Block object.
type Block struct {
	// Block number
	Number *int64 `json:"number,omitempty"`
	// Block hash
	Id *string `json:"id,omitempty"`
	// Parent block hash
	ParentId *string `json:"parent_id,omitempty"`
	// Block date in unix timestamp format
	Date *int64 `json:"date,omitempty"`
	// Amount of transaction in the block
	NumTxs *int32 `json:"num_txs,omitempty"`
	// List of normalized transactions presented in the block (not filtered or unknown model)
	Txs *[]Tx `json:"txs,omitempty"`
}

// NewBlock instantiates a new Block object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBlock() *Block {
	this := Block{}
	return &this
}

// NewBlockWithDefaults instantiates a new Block object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBlockWithDefaults() *Block {
	this := Block{}
	return &this
}

// GetNumber returns the Number field value if set, zero value otherwise.
func (o *Block) GetNumber() int64 {
	if o == nil || o.Number == nil {
		var ret int64
		return ret
	}
	return *o.Number
}

// GetNumberOk returns a tuple with the Number field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetNumberOk() (*int64, bool) {
	if o == nil || o.Number == nil {
		return nil, false
	}
	return o.Number, true
}

// HasNumber returns a boolean if a field has been set.
func (o *Block) HasNumber() bool {
	if o != nil && o.Number != nil {
		return true
	}

	return false
}

// SetNumber gets a reference to the given int64 and assigns it to the Number field.
func (o *Block) SetNumber(v int64) {
	o.Number = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Block) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Block) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Block) SetId(v string) {
	o.Id = &v
}

// GetParentId returns the ParentId field value if set, zero value otherwise.
func (o *Block) GetParentId() string {
	if o == nil || o.ParentId == nil {
		var ret string
		return ret
	}
	return *o.ParentId
}

// GetParentIdOk returns a tuple with the ParentId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetParentIdOk() (*string, bool) {
	if o == nil || o.ParentId == nil {
		return nil, false
	}
	return o.ParentId, true
}

// HasParentId returns a boolean if a field has been set.
func (o *Block) HasParentId() bool {
	if o != nil && o.ParentId != nil {
		return true
	}

	return false
}

// SetParentId gets a reference to the given string and assigns it to the ParentId field.
func (o *Block) SetParentId(v string) {
	o.ParentId = &v
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *Block) GetDate() int64 {
	if o == nil || o.Date == nil {
		var ret int64
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetDateOk() (*int64, bool) {
	if o == nil || o.Date == nil {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *Block) HasDate() bool {
	if o != nil && o.Date != nil {
		return true
	}

	return false
}

// SetDate gets a reference to the given int64 and assigns it to the Date field.
func (o *Block) SetDate(v int64) {
	o.Date = &v
}

// GetNumTxs returns the NumTxs field value if set, zero value otherwise.
func (o *Block) GetNumTxs() int32 {
	if o == nil || o.NumTxs == nil {
		var ret int32
		return ret
	}
	return *o.NumTxs
}

// GetNumTxsOk returns a tuple with the NumTxs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetNumTxsOk() (*int32, bool) {
	if o == nil || o.NumTxs == nil {
		return nil, false
	}
	return o.NumTxs, true
}

// HasNumTxs returns a boolean if a field has been set.
func (o *Block) HasNumTxs() bool {
	if o != nil && o.NumTxs != nil {
		return true
	}

	return false
}

// SetNumTxs gets a reference to the given int32 and assigns it to the NumTxs field.
func (o *Block) SetNumTxs(v int32) {
	o.NumTxs = &v
}

// GetTxs returns the Txs field value if set, zero value otherwise.
func (o *Block) GetTxs() []Tx {
	if o == nil || o.Txs == nil {
		var ret []Tx
		return ret
	}
	return *o.Txs
}

// GetTxsOk returns a tuple with the Txs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Block) GetTxsOk() (*[]Tx, bool) {
	if o == nil || o.Txs == nil {
		return nil, false
	}
	return o.Txs, true
}

// HasTxs returns a boolean if a field has been set.
func (o *Block) HasTxs() bool {
	if o != nil && o.Txs != nil {
		return true
	}

	return false
}

// SetTxs gets a reference to the given []Tx and assigns it to the Txs field.
func (o *Block) SetTxs(v []Tx) {
	o.Txs = &v
}

func (o Block) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Number != nil {
		toSerialize["number"] = o.Number
	}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.ParentId != nil {
		toSerialize["parent_id"] = o.ParentId
	}
	if o.Date != nil {
		toSerialize["date"] = o.Date
	}
	if o.NumTxs != nil {
		toSerialize["num_txs"] = o.NumTxs
	}
	if o.Txs != nil {
		toSerialize["txs"] = o.Txs
	}
	return json.Marshal(toSerialize)
}

type NullableBlock struct {
	value *Block
	isSet bool
}

func (v NullableBlock) Get() *Block {
	return v.value
}

func (v *NullableBlock) Set(val *Block) {
	v.value = val
	v.isSet = true
}

func (v NullableBlock) IsSet() bool {
	return v.isSet
}

func (v *NullableBlock) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBlock(val *Block) *NullableBlock {
	return &NullableBlock{value: val, isSet: true}
}

func (v NullableBlock) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBlock) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
